unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, SMInBase, SMIUPS, ComCtrls, ScktComp;

type
  TfrmMain = class(TForm)
    gbOptions: TGroupBox;
    MemoResults: TMemo;
    btnExecute: TButton;
    btnAbout: TButton;
    lblPackage: TLabel;
    edPackage: TEdit;
    SMUPSTracker: TSMUPSTracker;
    imgLogo: TImage;
    rbCurrentStatus: TRadioButton;
    rbFullTracking: TRadioButton;
    StatusBar: TStatusBar;
    procedure btnExecuteClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure SMUPSTrackerConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SMUPSTrackerConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SMUPSTrackerDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SMUPSTrackerError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure SMUPSTrackerLookup(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SMUPSTrackerReceiveTextFromSocket(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SMUPSTrackerSendTextToSocket(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
uses SMInCnst;

procedure TfrmMain.btnExecuteClick(Sender: TObject);
begin
  {define a package number}
  SMUPSTracker.TrackingNumber := edPackage.Text;

  {type of tracking}
  if rbCurrentStatus.Checked then
    SMUPSTracker.TrackingType := upsCurrentStatus
  else
    SMUPSTracker.TrackingType := upsFullTracking;

  {track a package}
  SMUPSTracker.Execute;

  {show a results}
  MemoResults.Lines.Text := '';
  MemoResults.Lines.Add('Tracking Number: ' + SMUPSTracker.GetUPSStatus(ssTrackingNumber));
  MemoResults.Lines.Add('Last Activity: ' + FormatDateTime('dddd, mmm dd, yyyy, tt', SMUPSTracker.GetActivityAsDateTime));
  MemoResults.Lines.Add('Last Status: ' + SMUPSTracker.GetUPSStatus(ssLastStatus));
  MemoResults.Lines.Add('');
  MemoResults.Lines.Add('Service Type: ' + SMUPSTracker.GetUPSStatus(ssServiceType));
  MemoResults.Lines.Add('Weight: ' + SMUPSTracker.GetUPSStatus(ssWeight) + ' ' + SMUPSTracker.GetUPSStatus(ssWeightUnits));
  MemoResults.Lines.Add('Signed By: ' + SMUPSTracker.GetUPSStatus(ssSignedBy));
  MemoResults.Lines.Add('Location: ' + SMUPSTracker.GetUPSStatus(ssLocation));
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  AboutSMInet
end;

procedure TfrmMain.SMUPSTrackerConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.SimpleText := 'Connected.';
end;

procedure TfrmMain.SMUPSTrackerConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.SimpleText := 'Connecting...';
end;

procedure TfrmMain.SMUPSTrackerDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.SimpleText := 'Disconnected.';
end;

procedure TfrmMain.SMUPSTrackerError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  StatusBar.SimpleText := 'Error: ' + IntToStr(ErrorCode);
end;

procedure TfrmMain.SMUPSTrackerLookup(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.SimpleText := 'Lookup...';
end;

procedure TfrmMain.SMUPSTrackerReceiveTextFromSocket(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.SimpleText := 'Receiving...';
end;

procedure TfrmMain.SMUPSTrackerSendTextToSocket(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.SimpleText := 'Sending...';
end;

end.
